package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolCampusBo;
import org.dromara.art.domain.vo.ArtSchoolCampusVo;
import org.dromara.art.domain.ArtSchoolCampus;
import org.dromara.art.mapper.ArtSchoolCampusMapper;
import org.dromara.art.service.IArtSchoolCampusService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校校区Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolCampusServiceImpl implements IArtSchoolCampusService {

    private final ArtSchoolCampusMapper baseMapper;

    /**
     * 查询学校校区
     *
     * @param campusId 主键
     * @return 学校校区
     */
    @Override
    public ArtSchoolCampusVo queryById(Long campusId){
        return baseMapper.selectVoById(campusId);
    }

    /**
     * 分页查询学校校区列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校校区分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolCampusVo> queryPageList(ArtSchoolCampusBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolCampus> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolCampusVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校校区列表
     *
     * @param bo 查询条件
     * @return 学校校区列表
     */
    @Override
    public List<ArtSchoolCampusVo> queryList(ArtSchoolCampusBo bo) {
        LambdaQueryWrapper<ArtSchoolCampus> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolCampus> buildQueryWrapper(ArtSchoolCampusBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolCampus> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolCampus::getCampusId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolCampus::getSchoolId, bo.getSchoolId());
        lqw.like(StringUtils.isNotBlank(bo.getCampusName()), ArtSchoolCampus::getCampusName, bo.getCampusName());
        lqw.eq(StringUtils.isNotBlank(bo.getLocation()), ArtSchoolCampus::getLocation, bo.getLocation());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), ArtSchoolCampus::getAddress, bo.getAddress());
        lqw.eq(bo.getLng() != null, ArtSchoolCampus::getLng, bo.getLng());
        lqw.eq(bo.getLat() != null, ArtSchoolCampus::getLat, bo.getLat());
        lqw.eq(StringUtils.isNotBlank(bo.getIntroduction()), ArtSchoolCampus::getIntroduction, bo.getIntroduction());
        return lqw;
    }

    /**
     * 新增学校校区
     *
     * @param bo 学校校区
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolCampusBo bo) {
        ArtSchoolCampus add = MapstructUtils.convert(bo, ArtSchoolCampus.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setCampusId(add.getCampusId());
        }
        return flag;
    }

    /**
     * 修改学校校区
     *
     * @param bo 学校校区
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolCampusBo bo) {
        ArtSchoolCampus update = MapstructUtils.convert(bo, ArtSchoolCampus.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolCampus entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校校区信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
